# -*- coding:Utf-8 -*-

import psyco
psyco.full()

import gamethread

class Decompte:
    """Classe représentant un décompte exécutant à chaque seconde une fonction donnée"""

    def __init__(self):
        """Construction par défaut, ne lance pas le décompte"""

        self.__tempsRestant = -1
        self.__callback = None


    def lanceDecompte(self,duree,callback):
        """
            Lance un décompte d'une certaine durée
            @param duree Durée (en secondes) du décompte
            @param callback Fonction à exécuter à chaque seconde du décompte
                (reçevra le nombre entier de secondes restant en paramètre)
        """

        # Mémorisation de la durée du décompte
        self.__tempsRestant = duree

        # Installation du callback
        self.__callback = callback

        # Lancement du décompte
        self.__joueDecompte()

    def __joueDecompte(self):
        """Décrémente le décompte et exécute la fonction associée"""

        # Si le décompte est terminé, on ne fait plus rien
        if self.__tempsRestant != -1:
            
            # Exécution du callback
            if callable(self.__callback):
                self.__callback(self.__tempsRestant)

            self.__tempsRestant -= 1
            gamethread.delayed(1, self.__joueDecompte, ())
        

    def stoppeDecompte(self):
        """Stoppe le décompte en cours"""
        self.__tempsRestant = -1


